## elisa-player 23.08.5

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 (c) Matthieu Gallien <matthieu_gallien@yahoo.fr>
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.8)

# KDE Applications version, managed by release script.
set(RELEASE_SERVICE_VERSION_MAJOR "23")
set(RELEASE_SERVICE_VERSION_MINOR "08")
set(RELEASE_SERVICE_VERSION_MICRO "5")
set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

project(elisa
    VERSION ${RELEASE_SERVICE_VERSION}
    LANGUAGES CXX)

set(REQUIRED_KF_VERSION "5.105.0")
find_package(ECM ${REQUIRED_KF_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMInstallIcons)
include(FeatureSummary)
include(ECMAddAppIcon)
include(ECMAddTests)
include(ECMQtDeclareLoggingCategory)
include(ECMGenerateQmlTypes)

set(REQUIRED_QT_VERSION "5.15.0")
if (ANDROID)
    set(REQUIRED_QT_VERSION "5.15.10")
endif()
find_package(Qt${QT_MAJOR_VERSION} ${REQUIRED_QT_VERSION} CONFIG REQUIRED Core Network Qml Quick Test Sql Multimedia Svg Gui Widgets QuickTest Concurrent QuickControls2)

find_package(Qt${QT_MAJOR_VERSION}Core ${REQUIRED_QT_VERSION} CONFIG REQUIRED Private)



if (NOT WIN32 AND NOT ANDROID)
    find_package(Qt${QT_MAJOR_VERSION}DBus ${REQUIRED_QT_VERSION} CONFIG QUIET)
    set_package_properties(Qt${QT_MAJOR_VERSION}DBus PROPERTIES
        DESCRIPTION "Qt${QT_MAJOR_VERSION} DBus is needed to provide MPris2 interface to allow remote control by the desktop workspace."
        TYPE OPTIONAL)
endif()

if (Qt${QT_MAJOR_VERSION}DBus_FOUND)
set(QtDBus_FOUND 1)
endif()

find_package(Qt${QT_MAJOR_VERSION}QuickWidgets ${REQUIRED_QT_VERSION} CONFIG QUIET)
set_package_properties(Qt${QT_MAJOR_VERSION}QuickWidgets PROPERTIES
    DESCRIPTION "Qt${QT_MAJOR_VERSION} Quick Widgets is needed at runtime to provide the interface."
    TYPE RUNTIME)

find_package(Qt${QT_MAJOR_VERSION}QuickControls2 ${REQUIRED_QT_VERSION} CONFIG QUIET)
set_package_properties(Qt${QT_MAJOR_VERSION}QuickControls2 PROPERTIES
    DESCRIPTION "Qt${QT_MAJOR_VERSION} Quick Controls version 2 is needed at runtime to provide the interface."
    TYPE RUNTIME)

if (ANDROID)
    find_package(Qt${QT_MAJOR_VERSION} ${REQUIRED_QT_VERSION} CONFIG QUIET OPTIONAL_COMPONENTS AndroidExtras)
    set_package_properties(Qt5AndroidExtras PROPERTIES
        DESCRIPTION "Qt5 AndroidExtras is needed to provide the Android integration."
        TYPE REQUIRED)
    set(QtAndroidExtras_FOUND 1)
endif()

find_package(KF${QT_MAJOR_VERSION}Kirigami2 ${REQUIRED_KF_VERSION} CONFIG QUIET)

set_package_properties(KF${QT_MAJOR_VERSION}Kirigami2 PROPERTIES
    DESCRIPTION "KF Kirigami 2 is needed to provide the mobile UI components."
    TYPE REQUIRED)

find_package(KF${QT_MAJOR_VERSION}I18n ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}I18n PROPERTIES
    DESCRIPTION "KF text internationalization library."
    TYPE REQUIRED)

find_package(KF${QT_MAJOR_VERSION}CoreAddons ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}CoreAddons PROPERTIES
    DESCRIPTION "Qt addon library with a collection of non-GUI utilities."
    TYPE REQUIRED)

find_package(KF${QT_MAJOR_VERSION}IconThemes ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}IconThemes PROPERTIES
    DESCRIPTION "Support for icon themes."
    TYPE REQUIRED)

if (NOT WIN32)
find_package(KF${QT_MAJOR_VERSION}Baloo ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}Baloo PROPERTIES
    DESCRIPTION "Baloo provides file searching and indexing."
    TYPE RECOMMENDED)
endif()

find_package(KF${QT_MAJOR_VERSION}FileMetaData ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}FileMetaData PROPERTIES
    DESCRIPTION "Provides a simple library for extracting metadata."
    TYPE RECOMMENDED)

find_package(KF${QT_MAJOR_VERSION}DocTools ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}DocTools PROPERTIES
    DESCRIPTION "Create documentation from DocBook library."
    TYPE OPTIONAL)

find_package(KF${QT_MAJOR_VERSION}XmlGui ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}XmlGui PROPERTIES
    DESCRIPTION "Framework for managing menu and toolbar actions."
    TYPE RECOMMENDED)

find_package(KF${QT_MAJOR_VERSION}Config ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}Config PROPERTIES
    DESCRIPTION "Persistent platform-independent application settings."
    TYPE REQUIRED)

find_package(KF${QT_MAJOR_VERSION}ConfigWidgets ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}ConfigWidgets PROPERTIES
    DESCRIPTION "Widgets for configuration dialogs."
    TYPE RECOMMENDED)

find_package(KF${QT_MAJOR_VERSION}Crash ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}Crash PROPERTIES
    DESCRIPTION "Graceful handling of application crashes."
    TYPE OPTIONAL)

if (NOT WIN32 AND NOT ANDROID)
    find_package(KF${QT_MAJOR_VERSION}DBusAddons ${REQUIRED_KF_VERSION} CONFIG QUIET)
    set_package_properties(KF${QT_MAJOR_VERSION}DBusAddons PROPERTIES
        DESCRIPTION "Convenience classes for D-Bus."
        TYPE OPTIONAL)
endif()

if (NOT ANDROID)
    find_package(KF${QT_MAJOR_VERSION}KIO ${REQUIRED_KF_VERSION} CONFIG QUIET)
    set_package_properties(KF${QT_MAJOR_VERSION}KIO PROPERTIES
        DESCRIPTION "File management libraries used for file browsing."
        TYPE REQUIRED)
endif()

find_package(UPNPQT CONFIG QUIET)
set_package_properties(UPNPQT PROPERTIES
    DESCRIPTION "UPNP layer build with Qt. UPnP support is currently broken. You should probably avoid this dependency."
    URL "https://gitlab.com/homeautomationqt/upnp-player-qt"
    TYPE OPTIONAL)

if (UPNPQT_FOUND)
    message(WARNING "UPnP support is experimental and may not work.")
endif()

find_package(LIBVLC QUIET)
set_package_properties(LIBVLC PROPERTIES
    DESCRIPTION "libvlc allows to play music in Elisa (otherwise it will use QtMultimedia)"
    URL "https://www.videolan.org/vlc/libvlc.html"
    TYPE RECOMMENDED)

include(FeatureSummary)
include(GenerateExportHeader)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMGenerateDBusServiceFile)
include(CMakePackageConfigHelpers)
include(ECMDeprecationSettings)

set(KFBaloo_FOUND ${KF${QT_MAJOR_VERSION}Baloo_FOUND})
set(KFXmlGui_FOUND ${KF${QT_MAJOR_VERSION}XmlGui_FOUND})
set(KFCrash_FOUND ${KF${QT_MAJOR_VERSION}Crash_FOUND})
set(KFDBusAddons_FOUND ${KF${QT_MAJOR_VERSION}DBusAddons_FOUND})
set(KFConfigWidgets_FOUND ${KF${QT_MAJOR_VERSION}ConfigWidgets_FOUND})
set(KFKIO_FOUND ${KF${QT_MAJOR_VERSION}KIO_FOUND})
set(KFFileMetaData_FOUND ${KF${QT_MAJOR_VERSION}FileMetaData_FOUND})

configure_file(config-upnp-qt.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-upnp-qt.h)

ecm_setup_version(${RELEASE_SERVICE_VERSION}
    VARIABLE_PREFIX ELISA
    VERSION_HEADER elisa-version.h)

set(QML_IMPORT_PATH ${CMAKE_BINARY_DIR}/bin CACHE STRING "" FORCE)

ecm_set_disabled_deprecation_versions(
    QT 5.15.2
    KF 5.101
)


add_subdirectory(src)
add_subdirectory(icons)
if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()
add_subdirectory(doc)

if (KF${QT_MAJOR_VERSION}DBusAddons_FOUND)
    ecm_generate_dbus_service_file(
        NAME org.kde.elisa
        EXECUTABLE ${KDE_INSTALL_FULL_BINDIR}/elisa
        DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR}
    )
    set(ELISA_DBUSACTIVATABLE "DBusActivatable=true")
else()
    set(ELISA_DBUSACTIVATABLE)
endif()

configure_file(org.kde.elisa.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/org.kde.elisa.desktop @ONLY)
install(
    PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/org.kde.elisa.desktop
    DESTINATION ${KDE_INSTALL_APPDIR}
)

install(
    FILES org.kde.elisa.appdata.xml
    DESTINATION ${KDE_INSTALL_METAINFODIR}
)

ki18n_install(po)
if (KF${QT_MAJOR_VERSION}DocTools_FOUND)
    kdoctools_install(po)
endif()

install(FILES elisa.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})

if (ANDROID)
    file(COPY androidResources/icon.png androidResources/splash.xml androidResources/vendor_logo.png androidResources/splash_logo.png
        DESTINATION ${CMAKE_SOURCE_DIR}/data/res/drawable)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/data/version.gradle.in ${CMAKE_BINARY_DIR}/version.gradle)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== doc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2017 (c) Matthieu Gallien <matthieu_gallien@yahoo.fr>
#
# SPDX-License-Identifier: LGPL-3.0-or-later

# documentation

if (KF${QT_MAJOR_VERSION}DocTools_FOUND)
    KDOCTOOLS_CREATE_HANDBOOK(
        index.docbook
            INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en
            SUBDIR elisa
    )
endif()

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2016 (c) Matthieu Gallien <matthieu_gallien@yahoo.fr>
#
# SPDX-License-Identifier: LGPL-3.0-or-later

include_directories(${elisa_BINARY_DIR})

set(elisaLib_SOURCES
    mediaplaylist.cpp
    mediaplaylistproxymodel.cpp
    progressindicator.cpp
    databaseinterface.cpp
    datatypes.cpp
    musiclistenersmanager.cpp
    managemediaplayercontrol.cpp
    manageheaderbar.cpp
    manageaudioplayer.cpp
    trackslistener.cpp
    elisaapplication.cpp
    modeldataloader.cpp
    elisautils.cpp
    abstractfile/abstractfilelistener.cpp
    abstractfile/abstractfilelisting.cpp
    filescanner.cpp
    filewriter.cpp
    viewmanager.cpp
    powermanagementinterface.cpp
    file/filelistener.cpp
    file/localfilelisting.cpp
    models/datamodel.cpp
    models/abstractmediaproxymodel.cpp
    models/gridviewproxymodel.cpp
    models/trackmetadatamodel.cpp
    models/editabletrackmetadatamodel.cpp
    models/trackcontextmetadatamodel.cpp
    models/viewsmodel.cpp
    models/viewsproxymodel.cpp
    models/lyricsmodel.cpp
    viewslistdata.cpp
    viewconfigurationdata.cpp
    localFileConfiguration/elisaconfigurationdialog.cpp
)

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "indexersManager.h"
    IDENTIFIER "orgKdeElisaIndexersManager"
    CATEGORY_NAME "org.kde.elisa.indexers.manager"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "databaseLogging.h"
    IDENTIFIER "orgKdeElisaDatabase"
    CATEGORY_NAME "org.kde.elisa.database"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "abstractfile/indexercommon.h"
    IDENTIFIER "orgKdeElisaIndexer"
    CATEGORY_NAME "org.kde.elisa.indexer"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "models/modelLogging.h"
    IDENTIFIER "orgKdeElisaModel"
    CATEGORY_NAME "org.kde.elisa.model"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "playListLogging.h"
    IDENTIFIER "orgKdeElisaPlayList"
    CATEGORY_NAME "org.kde.elisa.playlist"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "viewsLogging.h"
    IDENTIFIER "orgKdeElisaViews"
    CATEGORY_NAME "org.kde.elisa.views"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "playerLogging.h"
    IDENTIFIER "orgKdeElisaPlayer"
    CATEGORY_NAME "org.kde.elisa.player"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "powerManagementLogging.h"
    IDENTIFIER "orgKdeElisaPowerManagement"
    CATEGORY_NAME "org.kde.elisa.powermanagement"
    DEFAULT_SEVERITY Info
    )

if (LIBVLC_FOUND)
    ecm_qt_declare_logging_category(elisaLib_SOURCES
        HEADER "vlcLogging.h"
        IDENTIFIER "orgKdeElisaPlayerVlc"
        CATEGORY_NAME "org.kde.elisa.player.vlc"
        DEFAULT_SEVERITY Info
        )

    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        audiowrapper_libvlc.cpp
        )
else()
    ecm_qt_declare_logging_category(elisaLib_SOURCES
        HEADER "qtMultimediaLogging.h"
        IDENTIFIER "orgKdeElisaPlayerQtMultimedia"
        CATEGORY_NAME "org.kde.elisa.player.qtMultimedia"
        DEFAULT_SEVERITY Info
        )

    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        audiowrapper_qtmultimedia.cpp
        )
endif()

if (ANDROID)
    ecm_qt_declare_logging_category(elisaLib_SOURCES
        HEADER "android/androidcommon.h"
        IDENTIFIER "orgKdeElisaAndroid"
        CATEGORY_NAME "org.kde.elisa.android"
        DEFAULT_SEVERITY Info
        )

    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        android/androidmusiclistener.cpp
        android/androidfilelisting.cpp
        )
endif()

if (KF${QT_MAJOR_VERSION}KIO_FOUND)
    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        models/filebrowsermodel.cpp
        models/filebrowserproxymodel.cpp
        )
endif()

if (KF${QT_MAJOR_VERSION}Baloo_FOUND)
    if (Qt${QT_MAJOR_VERSION}DBus_FOUND)
        ecm_qt_declare_logging_category(elisaLib_SOURCES
            HEADER "baloo/baloocommon.h"
            IDENTIFIER "orgKdeElisaBaloo"
            CATEGORY_NAME "org.kde.elisa.baloo"
            DEFAULT_SEVERITY Info
            )

        set(elisaLib_SOURCES
            ${elisaLib_SOURCES}
            baloo/localbaloofilelisting.cpp
            baloo/baloolistener.cpp
            baloo/baloodetector.cpp
            )

        qt_add_dbus_interface(elisaLib_SOURCES
            ${BALOO_DBUS_INTERFACES_DIR}/org.kde.baloo.main.xml
            baloo/main)

        qt_add_dbus_interface(elisaLib_SOURCES
            ${BALOO_DBUS_INTERFACES_DIR}/org.kde.baloo.fileindexer.xml
            baloo/fileindexer)

        qt_add_dbus_interface(elisaLib_SOURCES
            ${BALOO_DBUS_INTERFACES_DIR}/org.kde.baloo.scheduler.xml
            baloo/scheduler)

        qt_add_dbus_adaptor(elisaLib_SOURCES
            ${BALOO_DBUS_INTERFACES_DIR}/org.kde.BalooWatcherApplication.xml
            baloo/localbaloofilelisting.h LocalBalooFileListing)
    endif()
endif()

if (Qt${QT_MAJOR_VERSION}DBus_FOUND)
    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        mpris2/mpris2.cpp
        mpris2/mediaplayer2.cpp
        mpris2/mediaplayer2player.cpp
        )
endif()

if (UPNPQT_FOUND)
    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        upnp/upnpcontrolcontentdirectory.cpp
        upnp/upnpcontentdirectorymodel.cpp
        upnp/upnpcontrolconnectionmanager.cpp
        upnp/upnpcontrolmediaserver.cpp
        upnp/didlparser.cpp
        upnp/upnplistener.cpp
        upnp/upnpdiscoverallmusic.cpp
        )
endif()

if (KF${QT_MAJOR_VERSION}Baloo_FOUND)
    if (Qt${QT_MAJOR_VERSION}DBus_FOUND)
        qt_add_dbus_interface(elisaLib_SOURCES
            ${BALOO_DBUS_INTERFACES_DIR}/org.kde.baloo.fileindexer.xml
            baloo/fileindexer)

        qt_add_dbus_interface(elisaLib_SOURCES
            ${BALOO_DBUS_INTERFACES_DIR}/org.kde.baloo.scheduler.xml
            baloo/scheduler)

        set(elisaLib_SOURCES
            ${elisaLib_SOURCES}
            ../src/baloo/baloolistener.cpp
            ../src/baloo/localbaloofilelisting.cpp
            )
    endif()
endif()

kconfig_add_kcfg_files(elisaLib_SOURCES ../src/elisa_settings.kcfgc GENERATE_MOC )
set(elisaLib_SOURCES
    ${elisaLib_SOURCES}
    ../src/elisa_core.kcfg
    )

add_library(elisaLib ${elisaLib_SOURCES})
target_link_libraries(elisaLib
    LINK_PUBLIC
    Qt::Multimedia
    LINK_PRIVATE
    Qt::Core Qt::Sql Qt::Widgets Qt::Concurrent Qt::Qml
    KF${QT_MAJOR_VERSION}::I18n KF${QT_MAJOR_VERSION}::CoreAddons
    KF${QT_MAJOR_VERSION}::ConfigCore KF${QT_MAJOR_VERSION}::ConfigGui)

if (KF${QT_MAJOR_VERSION}FileMetaData_FOUND)
    target_link_libraries(elisaLib
        LINK_PRIVATE
        KF${QT_MAJOR_VERSION}::FileMetaData
        )
endif()

if (KF${QT_MAJOR_VERSION}KIO_FOUND)
    target_link_libraries(elisaLib
        LINK_PUBLIC
        KF${QT_MAJOR_VERSION}::KIOCore KF${QT_MAJOR_VERSION}::KIOFileWidgets KF${QT_MAJOR_VERSION}::KIOWidgets
        )
endif()

if (KF${QT_MAJOR_VERSION}XmlGui_FOUND)
    target_link_libraries(elisaLib
        LINK_PUBLIC
        KF${QT_MAJOR_VERSION}::XmlGui
        )
endif()

if (KF${QT_MAJOR_VERSION}ConfigWidgets_FOUND)
    target_link_libraries(elisaLib
        LINK_PUBLIC
        KF${QT_MAJOR_VERSION}::ConfigWidgets
        )
endif()

if (KF${QT_MAJOR_VERSION}Baloo_FOUND)
    if (Qt${QT_MAJOR_VERSION}DBus_FOUND)
        target_link_libraries(elisaLib
            LINK_PUBLIC
            KF${QT_MAJOR_VERSION}::Baloo
            )
    endif()
endif()

if (Qt${QT_MAJOR_VERSION}DBus_FOUND)
    target_link_libraries(elisaLib
        LINK_PUBLIC
        Qt::DBus
        )

    if (KF${QT_MAJOR_VERSION}DBusAddons_FOUND)
        target_link_libraries(elisaLib
            LINK_PUBLIC
            KF${QT_MAJOR_VERSION}::DBusAddons
            )
    endif()
endif()

if (LIBVLC_FOUND)
    target_include_directories(elisaLib
        PRIVATE
        ${LIBVLC_INCLUDE_DIR}
        )

    target_link_libraries(elisaLib
        LINK_PRIVATE
        ${LIBVLC_LIBRARY}
        )
endif()

if (ANDROID)
    target_link_libraries(elisaLib
        LINK_PUBLIC
        Qt::AndroidExtras
        )
endif()

generate_export_header(elisaLib BASE_NAME ElisaLib EXPORT_FILE_NAME elisaLib_export.h)

set_target_properties(elisaLib PROPERTIES
    VERSION 0.1
    SOVERSION 0
    EXPORT_NAME ElisaLib
    )

if (NOT APPLE AND NOT WIN32)
    install(TARGETS elisaLib
        LIBRARY DESTINATION ${KDE_INSTALL_FULL_LIBDIR}/elisa NAMELINK_SKIP
        RUNTIME DESTINATION ${KDE_INSTALL_FULL_LIBDIR}/elisa
        BUNDLE DESTINATION ${KDE_INSTALL_FULL_LIBDIR}/elisa
        )
else()
    install(TARGETS elisaLib ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()

set(elisaqmlplugin_SOURCES
    elisaqmlplugin.cpp
    elisautils.cpp
)

if (KF${QT_MAJOR_VERSION}FileMetaData_FOUND)
    set(elisaqmlplugin_SOURCES
        ${elisaqmlplugin_SOURCES}
        embeddedcoverageimageprovider.cpp
    )
endif()

add_library(elisaqmlplugin SHARED ${elisaqmlplugin_SOURCES})
target_link_libraries(elisaqmlplugin
    LINK_PRIVATE
    Qt::Quick Qt::Widgets
    KF${QT_MAJOR_VERSION}::ConfigCore KF${QT_MAJOR_VERSION}::ConfigGui
    elisaLib
    )

if(QT_MAJOR_VERSION STREQUAL "6")
    target_sources(elisaqmlplugin PUBLIC res-qt6.qrc)
else()
    target_sources(elisaqmlplugin PUBLIC res-qt5.qrc)
endif()

if (KF${QT_MAJOR_VERSION}FileMetaData_FOUND)
    target_link_libraries(elisaqmlplugin
        LINK_PRIVATE
        KF${QT_MAJOR_VERSION}::FileMetaData
        )
endif()

set_target_properties(elisaqmlplugin PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/org/kde/elisa
    )

if (NOT APPLE AND NOT WIN32)
    set_target_properties(elisaqmlplugin PROPERTIES
        INSTALL_RPATH "${KDE_INSTALL_FULL_LIBDIR}/elisa;${CMAKE_INSTALL_RPATH}"
        )
endif()

install(TARGETS elisaqmlplugin DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/elisa/)

install(FILES qmldir DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/elisa)

add_custom_target(copy)
add_custom_target(copy2)

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/bin/org/kde/elisa)

add_custom_command(TARGET copy PRE_BUILD
    COMMAND ${CMAKE_COMMAND} -E
    copy ${CMAKE_CURRENT_SOURCE_DIR}/qmldir ${CMAKE_BINARY_DIR}/bin/org/kde/elisa
    )

add_custom_command(TARGET copy2 PRE_BUILD
    COMMAND ${CMAKE_COMMAND} -E
    copy ${CMAKE_CURRENT_SOURCE_DIR}/plugins.qmltypes ${CMAKE_BINARY_DIR}/bin/org/kde/elisa/
    )

add_dependencies(elisaqmlplugin copy copy2)

ecm_generate_qmltypes(org.kde.elisa 1.0
                      DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/elisa)

if (Qt${QT_MAJOR_VERSION}Quick_FOUND AND Qt${QT_MAJOR_VERSION}Widgets_FOUND)
    if(QT_MAJOR_VERSION STREQUAL "6")
        set(KIRIGAMI_ICON_SOURCE "icon.source")
        set(KIRIGAMI_PAGE_ACTIONS "actions")
    else()
        set(KIRIGAMI_ICON_SOURCE "icon")
        set(KIRIGAMI_PAGE_ACTIONS "contextualActions")
    endif()
    # The qrc paths need to be relative, or we adjust all of them :/
    configure_file(resources.qrc.in ${CMAKE_CURRENT_SOURCE_DIR}/resources.generated.qrc)
    configure_file(qml/ApplicationMenu.qml ${CMAKE_CURRENT_BINARY_DIR}/qml/ApplicationMenu.qml)
    configure_file(qml/mobile/MobilePlayListDelegate.qml ${CMAKE_CURRENT_BINARY_DIR}/qml/mobile/MobilePlayListDelegate.qml)
    configure_file(qml/GridBrowserDelegate.qml ${CMAKE_CURRENT_BINARY_DIR}/qml/GridBrowserDelegate.qml)
    configure_file(qml/ListBrowserDelegate.qml ${CMAKE_CURRENT_BINARY_DIR}/qml/ListBrowserDelegate.qml)
    configure_file(qml/ViewSelector.qml ${CMAKE_CURRENT_BINARY_DIR}/qml/ViewSelector.qml)
    configure_file(qml/mobile/MobileMediaTrackMetadataView.qml ${CMAKE_CURRENT_BINARY_DIR}/qml/mobile/MobileMediaTrackMetadataView.qml)

    set(elisa_SOURCES
        main.cpp

        windows/WindowsTheme.qml
        windows/PlatformIntegration.qml

        android/PlatformIntegration.qml

=== debian/changelog ===
elisa-player (23.08.5-0ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:51:02 +0000

elisa-player (23.08.5-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:18:09 +0000

elisa-player (23.08.5-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.5)

 -- Scarlett Moore <sgmoore@debian.org>  Thu, 22 Feb 2024 09:29:54 -0700

=== debian/control ===
Source: elisa-player
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: baloo-kf5-dev (>= 5.98.0~),
               cmake (>= 3.8~),
               debhelper-compat (= 13),
               dh-sequence-kf5,
               extra-cmake-modules (>= 5.98.0~),
               gettext,
               kirigami2-dev (>= 5.98.0~),
               libkf5config-dev (>= 5.98.0~),
               libkf5configwidgets-dev (>= 5.98.0~),
               libkf5coreaddons-dev (>= 5.98.0~),
               libkf5crash-dev (>= 5.98.0~),
               libkf5dbusaddons-dev (>= 5.98.0~),
               libkf5declarative-dev (>= 5.90.0~),
               libkf5doctools-dev (>= 5.98.0~),
               libkf5filemetadata-dev (>= 5.98.0~),
               libkf5i18n-dev (>= 5.98.0~),
               libkf5kcmutils-dev (>= 5.77.0~),
               libkf5kio-dev (>= 5.98.0~),
               libkf5package-dev (>= 5.98.0~),
               libkf5xmlgui-dev (>= 5.98.0~),
               libqt5svg5-dev (>= 5.15.8~),
               libvlc-dev,
               libvlccore-dev,
               pkg-config,
               qtbase5-dev (>= 5.15.8~),
               qtbase5-private-dev (>= 5.15.8~),
               qtdeclarative5-dev (>= 5.15.8~),
               qtmultimedia5-dev (>= 5.15.8~),
               qtquickcontrols2-5-dev (>= 5.15.8~),
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/multimedia/elisa
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/elisa
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/elisa

Package: elisa
Architecture: any
Depends: breeze-icon-theme (>= 5.77.0~),
         libqt5multimedia5-plugins (>= 5.15.0~),
         libqt5sql5-sqlite (>= 5.15.0~),
         qml-module-org-kde-kcm (>= 5.77.0~),
         qml-module-org-kde-kirigami2 (>= 5.77.0~),
         qml-module-qt-labs-platform (>= 5.15.0~),
         qml-module-qt-labs-settings (>= 5.15.0~),
         qml-module-qtgraphicaleffects (>= 5.15.0~),
         qml-module-qtqml (>= 5.15.0~),
         qml-module-qtqml-models2 (>= 5.15.0~),
         qml-module-qtquick-controls2 (>= 5.15.0~),
         qml-module-qtquick-dialogs (>= 5.15.0~),
         qml-module-qtquick-layouts (>= 5.15.0~),
         qml-module-qtquick-window2 (>= 5.15.0~),
         qml-module-qtquick2 (>= 5.15.0~),
         vlc-plugin-base,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Simple music player with a focus on Plasma desktop integration and privacy
 Elisa is a music player developed by the KDE community that strives to be
 simple and nice to use. It tries to be flexible to account for different
 workflows and use-cases. It focuses on a very good integration with the
 Plasma desktop of the KDE community without compromising the support for
 other environments.
 .
 Elisa is developed using modern KDE technologies and aims to be reliable
 and respectful of users’ privacy. As such, it favors online services where
 users are in control of their data.

## elisa-player 24.08.1

=== debian/changelog ===
elisa-player (24.08.1-0ubuntu1) oracular; urgency=medium

  * New upsream release (24.08.1)

 -- Rik Mills <rikmills@kde.org>  Fri, 13 Sep 2024 06:23:48 +0100

elisa-player (24.08.0-1ubuntu1) oracular; urgency=medium

  * Merge debian experimental.

 -- Scarlett Moore <sgmoore@debian.org>  Wed, 04 Sep 2024 10:04:11 -0700

elisa-player (24.08.0-1) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * Add missing QML runtime dependencies.
  * New upstream release (24.08.0).
  * Update build-deps and deps with the info from cmake.
  * Switch build dependency from transitional pkg-config to pkgconf.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 24 Aug 2024 12:12:27 +0200

elisa-player (24.05.2-1) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (24.05.2).
  * Update build-deps and deps with the info from cmake.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 21 Jul 2024 01:03:05 +0200

elisa-player (23.08.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - compatible with newer versions of the Baloo Framework (Closes: #1071305)
  * Update the build dependencies according to the upstream build system:
    - bump KF packages to 5.105.0
  * Bump Standards-Version to 4.7.0, no changes required.
  * Temporary switch the watch file to Attic, since we are following KF5
    versions for now.

 -- Pino Toscano <pino@debian.org>  Thu, 23 May 2024 12:06:08 +0200

=== debian/control ===
Source: elisa-player
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               extra-cmake-modules (>= 6.3~),
               gettext,
               kirigami-addons-dev (>= 0.11.76~),
               libkf6colorscheme-dev (>= 6.3~),
               libkf6config-dev (>= 6.3~),
               libkf6configwidgets-dev (>= 5.240.0~),
               libkf6coreaddons-dev (>= 6.3~),
               libkf6crash-dev (>= 6.3~),
               libkf6dbusaddons-dev (>= 6.3~),
               libkf6doctools-dev (>= 5.240.0~),
               libkf6filemetadata-dev (>= 6.3~),
               libkf6i18n-dev (>= 6.3~),
               libkf6iconthemes-dev (>= 6.3~),
               libkf6kio-dev (>= 6.3~),
               libkf6qqc2desktopstyle-dev (>= 6.3~),
               libkf6xmlgui-dev (>= 6.3~),
               libkirigami-dev (>= 6.3~),
               libvlc-dev,
               libvlccore-dev,
               pkgconf,
               qt6-base-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qt6-multimedia-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://invent.kde.org/multimedia/elisa
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/elisa
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/elisa

Package: elisa
Architecture: any
Depends: kf6-breeze-icon-theme,
         libqt6sql6-sqlite (>= 6.5.0~),
         qml6-module-org-kde-kirigami (>= 5.240.0~),
         qml6-module-org-kde-kirigamiaddons-formcard (>= 0.11.76~),
         qml6-module-qt-labs-platform (>= 6.5.0~),
         qml6-module-qt5compat-graphicaleffects (>= 6.5.0~),
         qml6-module-qtcore (>= 6.5.0~),
         qml6-module-qtmultimedia (>= 6.5.0~),
         qml6-module-qtqml (>= 6.5.0~),
         qml6-module-qtqml-models (>= 6.5.0~),
         qml6-module-qtqml-workerscript (>= 6.5.0~),
         qml6-module-qtquick (>= 6.5.0~),
         qml6-module-qtquick-controls (>= 6.5.0~),
         qml6-module-qtquick-dialogs (>= 6.5.0~),
         qml6-module-qtquick-layouts (>= 6.5.0~),
         qml6-module-qtquick-templates (>= 6.5.0~),
         qml6-module-qtquick-window (>= 6.5.0~),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Simple music player with a focus on Plasma desktop integration and privacy
 Elisa is a music player developed by the KDE community that strives to be
 simple and nice to use. It tries to be flexible to account for different
 workflows and use-cases. It focuses on a very good integration with the
 Plasma desktop of the KDE community without compromising the support for
 other environments.
 .
 Elisa is developed using modern KDE technologies and aims to be reliable
 and respectful of users’ privacy. As such, it favors online services where
 users are in control of their data.

## elisa-player 24.08.2

=== debian/changelog ===
elisa-player (24.08.2-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.08.2)

 -- Rik Mills <rikmills@kde.org>  Mon, 04 Nov 2024 08:59:25 +0000

## elisa-player 24.12.0

=== debian/changelog ===
elisa-player (24.12.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Update project homepage.
  * New upstream release (24.12.0).
  * Update build-deps and deps with the info from cmake.
  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 21 Dec 2024 22:53:20 +0100

elisa-player (24.08.2-1) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * Replace manual management of runtime QML dependencies with dh_qmldeps.
  * New upstream release (24.08.2).
  * Review copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 24 Oct 2024 23:15:46 +0200

elisa-player (23.08.5-2) unstable; urgency=medium

  * Team upload.
  * Build-depend on libkf6baloo-dev (Closes: #1080104)

 -- Salvo 'LtWorf' Tomaselli <ltworf@debian.org>  Tue, 10 Sep 2024 23:11:18 +0200

## elisa-player 24.12.1

=== debian/changelog ===
elisa-player (24.12.1-1) unstable; urgency=medium

  * New upstream release

 -- Salvo 'LtWorf' Tomaselli <ltworf@debian.org>  Fri, 17 Jan 2025 21:58:46 +0100

=== debian/control ===
Source: elisa-player
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-qmldeps,
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.3~),
               gettext,
               kirigami-addons-dev (>= 0.11.76~),
               libkf6baloo-dev,
               libkf6colorscheme-dev (>= 6.3~),
               libkf6config-dev (>= 6.3~),
               libkf6configwidgets-dev (>= 5.240.0~),
               libkf6coreaddons-dev (>= 6.3~),
               libkf6crash-dev (>= 6.3~),
               libkf6dbusaddons-dev (>= 6.3~),
               libkf6doctools-dev (>= 5.240.0~),
               libkf6filemetadata-dev (>= 6.3~),
               libkf6i18n-dev (>= 6.3~),
               libkf6iconthemes-dev (>= 6.3~),
               libkf6kio-dev (>= 6.3~),
               libkf6qqc2desktopstyle-dev (>= 6.3~),
               libkf6xmlgui-dev (>= 6.3~),
               libkirigami-dev (>= 6.3~),
               libvlc-dev,
               libvlccore-dev,
               pkgconf,
               qml6-module-qt5compat-graphicaleffects,
               qml6-module-qtcore,
               qml6-module-qtquick-dialogs,
               qt6-base-dev (>= 6.5.0~),
               qt6-base-private-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qt6-declarative-private-dev,
               qt6-multimedia-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://apps.kde.org/elisa/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/elisa
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/elisa.git

Package: elisa
Architecture: any
Depends: kf6-breeze-icon-theme,
         libqt6sql6-sqlite (>= 6.5.0~),
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: Simple music player with a focus on Plasma desktop integration and privacy
 Elisa is a music player developed by the KDE community that strives to be
 simple and nice to use. It tries to be flexible to account for different
 workflows and use-cases. It focuses on a very good integration with the
 Plasma desktop of the KDE community without compromising the support for
 other environments.
 .
 Elisa is developed using modern KDE technologies and aims to be reliable
 and respectful of users’ privacy. As such, it favors online services where
 users are in control of their data.
